# Hurried... awful... ugly... code... aah! (Seriously.)

import math, os, sys
import pyglet
import util
import const

class GameWindow(pyglet.window.Window):

    def __init__(self):
        super(GameWindow, self).__init__(const.WIDTH, const.HEIGHT,
                                         'Even Robots have Bad Dreams')

        self.start_menu()

    def start_menu(self):
        self.current_window = Menu(self)

    def start_game(self):
        self.current_window = Game(self)

    def start_level_editor(self):
        self.current_window = LevelEditor(self)


class Menu:

    def __init__(self, window):
        self.window = window

        self.batch = pyglet.graphics.Batch()
        self.bg = pyglet.sprite.Sprite(pyglet.resource.image('intro.png'),
                                       0, 0, batch=self.batch)
        
        self.window.push_handlers(self.on_draw, self.on_mouse_press)

    def finish(self):
        self.window.pop_handlers()
        
    def on_draw(self):
        self.window.clear()
        self.batch.draw()

    def on_mouse_press(self, x, y, button, modifiers):
        if button == pyglet.window.mouse.LEFT:
            if x >= 611 and y < 409 and x < 692 and y >= 354:
                self.finish()
                self.window.start_game()
            elif x >= 561 and y < 335 and x < 739 and y >= 292:
                self.finish()
                self.window.start_level_editor()
            elif x >= 608 and y < 268 and x < 695 and y >= 225:
                self.finish()
                self.window.close()


class Game:
    
    def __init__(self, window):
        self.window = window

        self.batch = pyglet.graphics.Batch()
        
        self.window.push_handlers(self.on_draw, self.on_mouse_press,
                                  self.on_key_press)

        self.level = 1

        self.tile_manager = TileManager(self.batch, False, self.level)

        self.sidebar = SidebarManager(self.window, self.batch,
                                      self.tile_manager, False)
         
        self.mouse_x = 0
        self.mouse_y = 0

        pyglet.clock.schedule_interval(self.update, 1/40.0)

    def finish(self):
        self.sidebar.finish()
        self.window.pop_handlers()
        self.window.start_menu()

    def find_pos_grid(self, x, y):
        return (x / const.TILESIZE, y / const.TILESIZE)
        
    def on_draw(self):
        self.window.clear()
        self.batch.draw()

    def on_mouse_press(self, x, y, button, modifiers):
        if button == pyglet.window.mouse.LEFT:
            if x < const.WIDTH - self.sidebar.width:
                pos_grid = self.find_pos_grid(x, y)
                if self.sidebar.mode == const.LEMODE_DELETE:
                    if self.tile_manager.can_remove_game(*pos_grid):
                        self.sidebar.unchoose(self.tile_manager.
                                              grid[pos_grid[0]][pos_grid[1]])
                        self.tile_manager.remove_icon(*pos_grid)
                elif self.sidebar.mode == const.LEMODE_INSERT:
                    if self.tile_manager.add(pos_grid[0], pos_grid[1],
                                          self.sidebar.insert_icon, False):
                        self.sidebar.unselectable_selected()

    def on_key_press(self, symbol, modifiers):
        if symbol == pyglet.window.key.Q:
            self.finish()
        elif symbol == pyglet.window.key.N:
            self.next_level()

    def next_level(self):
        self.level += 1
        if self.level <= const.MAX_LEVEL:
            # Don't look at this part! Gaah! Big memory leak!
            self.batch = pyglet.graphics.Batch()
            pyglet.clock.unschedule(self.sidebar.update)
            pyglet.clock.unschedule(self.sidebar.simulator.update)            
            self.tile_manager = TileManager(self.batch, False, self.level)
            self.sidebar = SidebarManager(self.window, self.batch,
                                          self.tile_manager, False)
        else:
            print 'Sorry for the abrupt exit, but you win! :)'
            sys.exit()

    def update(self, dt):
        if self.sidebar.simulator.level_done:
            self.next_level()
            

class LevelEditor:

    def __init__(self, window):
        self.window = window

        self.batch = pyglet.graphics.Batch()
        
        self.window.push_handlers(self.on_draw, self.on_mouse_press,
                                  self.on_key_press)

        self.tile_manager = TileManager(self.batch, True)

        self.sidebar = SidebarManager(self.window, self.batch,
                                      self.tile_manager, True)
         
        self.mouse_x = 0
        self.mouse_y = 0

    def finish(self):
        self.sidebar.finish()
        self.window.pop_handlers()
        self.window.start_menu()

    def find_pos_grid(self, x, y):
        return (x / const.TILESIZE, y / const.TILESIZE)
        
    def on_draw(self):
        self.window.clear()
        self.batch.draw()

    def on_mouse_press(self, x, y, button, modifiers):
        if button == pyglet.window.mouse.LEFT:
            if x < const.WIDTH - self.sidebar.width:
                pos_grid = self.find_pos_grid(x, y)
                if self.sidebar.mode == const.LEMODE_DELETE:
                    self.tile_manager.remove(*pos_grid)
                elif self.sidebar.mode == const.LEMODE_INSERT:
                    self.tile_manager.add(pos_grid[0], pos_grid[1],
                                          self.sidebar.insert_icon)
                else:
                    self.tile_manager.toggle_fix(*pos_grid)

    def on_key_press(self, symbol, modifiers):
        if symbol == pyglet.window.key.Q:
            self.finish()
        elif symbol == pyglet.window.key.S:
            self.tile_manager.save_grid_editor()
        elif symbol == pyglet.window.key.L:
            self.tile_manager.load_grid_editor()
        elif symbol == pyglet.window.key.C:
            self.tile_manager.clear_grid()
                    

class Selection(pyglet.sprite.Sprite):

    def __init__(self, sprite, s_type, batch, group):
        if s_type == const.SELECT_YLWSQR:
            image_file = 'select-square-yellow.png'
        elif s_type == const.SELECT_GRNSQR:
            image_file = 'select-square-green.png'            
        image = pyglet.resource.image(image_file)
        
        super(Selection, self).__init__(image, batch=batch, group=group)

        self.sprite = sprite
        self.update()

    def update(self):
        self.x = self.sprite.x + self.sprite.width/2 - self.image.width/2
        self.y = self.sprite.y + self.sprite.height/2 - self.image.height/2
        

class Switch(pyglet.sprite.Sprite):

    def __init__(self, x, y, batch, group):
        self.image_off = pyglet.resource.image('switch-off.png')
        self.image_on = pyglet.resource.image('switch-on.png')
        
        super(Switch, self).__init__(self.image_off, x=x, y=y, batch=batch,
                                     group=group)

        self.switched = False

    def activate(self):
        if self.switched:
            self.image = self.image_off
        else:
            self.image = self.image_on          
        self.switched = not self.switched

    def on_mouse_press(self, selected_robot):
        selected_robot.investigate(self)


class TileManager:

    def __init__(self, batch, editor, level=0):
        self.batch = batch
        self.wgroup = pyglet.graphics.OrderedGroup(0)
        self.fgroup = pyglet.graphics.OrderedGroup(1)
        self.igroup = pyglet.graphics.OrderedGroup(2)
        self.rgroup = pyglet.graphics.OrderedGroup(3)
        self.walls = []

        self.n_tiles_x = 20
        self.n_tiles_y = 15
        self.tilesize = const.TILESIZE
        self.floor_grid = [[None for j in xrange(self.n_tiles_y)]
                           for i in xrange(self.n_tiles_x)]
        self.grid = [[None for j in xrange(self.n_tiles_y)]
                     for i in xrange(self.n_tiles_x)]
        self.robot_grid = [[None for j in xrange(self.n_tiles_y)]
                           for i in xrange(self.n_tiles_x)]
        self.robots = []
        self.things = [[] for i in xrange(const.NTHINGS)]
        self.backup = []
        self.not_fixed = []

        if editor:
            self.load_grid_editor()
        else:
            self.load_grid_game(level)

        self.generate_walls()

    def add_icon(self, x, y, icon):
        if self.floor_grid[x][y]:
            self.grid[x][y] = icon

    def check_add_icon(self, x, y, icon):
        return (self.floor_grid[x][y] and
                not (self.robot_grid[x][y] and (icon.startswith('thing'))))

    def add_floor(self, x, y):
        self.floor_grid[x][y] = Tile(x, y, self.batch, self.fgroup)
        self.generate_walls()

    def add_robot(self, x, y):
        robot = Robot(x, y, self.batch, self.rgroup, self)
        self.robot_grid[x][y] = robot
        self.robots.append(robot)

    def add(self, x, y, icon, fixed=True):
        if icon == 'floor':
            self.add_floor(x, y)
        elif icon == 'robot':
            self.add_robot(x, y)
        else:
            if not self.check_add_icon(x, y, icon):
                return False
            if icon == 'shock':
                sprite = ShockTrap(x, y, self.batch, self.igroup, self, fixed)
                if not fixed: self.not_fixed.append(sprite)
            elif icon == 'chips':
                sprite = BagOfChips(x, y, self.batch, self.igroup, self,
                                    fixed)
                if not fixed: self.not_fixed.append(sprite)                
            elif icon.startswith('thing'):
                t_num = int(icon[-2:])
                sprite = Thing(t_num, x, y, self.batch, self.igroup, self,
                               fixed)
                if not fixed: self.not_fixed.append(sprite)
                self.things[t_num-1].append(sprite)
            elif icon == 'exit':
                sprite = Exit(x, y, self.batch, self.igroup, self)
            self.add_icon(x, y, sprite)
        return True

    def generate_walls(self):
        for x in range(self.n_tiles_x):
            for y in range(self.n_tiles_y):
                if self.floor_grid[x][y] is not None:
                    if x > 0 and self.floor_grid[x-1][y] == None:
                        self.walls.append(Wall(x, y, self.batch, self.wgroup,
                                               self.tilesize, 'left'))
                    if x < 19 and self.floor_grid[x+1][y] == None:
                        self.walls.append(Wall(x, y, self.batch, self.wgroup,
                                               self.tilesize, 'right'))
                    if y > 0 and self.floor_grid[x][y-1] == None:
                        self.walls.append(Wall(x, y, self.batch, self.wgroup,
                                               self.tilesize, 'top'))
                    if y < 14 and self.floor_grid[x][y+1] == None:
                        self.walls.append(Wall(x, y, self.batch, self.wgroup,
                                               self.tilesize, 'bottom'))

    def remove_floor(self, x, y):
        if self.floor_grid[x][y]:
            self.floor_grid[x][y].delete()
            self.floor_grid[x][y] = None
            self.erase_walls()
            self.generate_walls()

    def erase_walls(self):
        for wall in self.walls:
            wall.delete()
        self.walls = []

    def remove(self, x, y):
        if self.robot_grid[x][y] == None:
            if self.grid[x][y] == None:
                self.remove_floor(x, y)
            else:
                self.remove_icon(x, y)
        else:
            self.remove_robot(x, y)

    def remove_icon(self, x, y):
        if self.grid[x][y]:
            if self.grid[x][y].tnumber > 0:
                self.things[self.grid[x][y].tnumber-1].remove(self.grid[x][y])
            if not self.grid[x][y].fixed:
                self.not_fixed.remove(self.grid[x][y])
            self.grid[x][y].delete()
            self.grid[x][y] = None

    def remove_robot(self, x, y):
        if self.robot_grid[x][y]:
            self.robots.remove(self.robot_grid[x][y])
            self.robot_grid[x][y].delete()
            self.robot_grid[x][y] = None

    def can_remove_game(self, x, y):
        return self.grid[x][y] and not self.grid[x][y].fixed

    def clear_grid(self):
        self.erase_walls()
        self.robots = []
        self.things = [[] for i in xrange(const.NTHINGS)]
        self.backup = []
        self.not_fixed = []
        for x in range(self.n_tiles_x):
            for y in range(self.n_tiles_y):
                if self.floor_grid[x][y]:
                    self.floor_grid[x][y].delete()
                    self.floor_grid[x][y] = None
                if self.grid[x][y]:
                    self.grid[x][y].delete()
                    self.grid[x][y] = None
                if self.robot_grid[x][y]:
                    self.robot_grid[x][y].delete()
                    self.robot_grid[x][y] = None

    def load_grid(self, filename):
        f = pyglet.resource.file(filename).readlines()        
        self.clear_grid()
        for line in f:
            line = line.split()
            if len(line) <= 3:
                self.add(int(line[1]), int(line[2]), line[0])
            else:
                if line[3] == 'True':
                    fixed = True
                else:
                    fixed = False
                self.add(int(line[1]), int(line[2]), line[0], fixed)
    
    def load_grid_editor(self):
        self.load_grid(const.EDITOR_FILE)
                
    def load_grid_game(self, level):
        self.load_grid('level%02d.dat' % level)
        for x in range(self.n_tiles_x):
            for y in range(self.n_tiles_y):
                if self.grid[x][y] and not self.grid[x][y].fixed:
                    self.grid[x][y].delete()
                    self.grid[x][y] = None

    def save_grid_editor(self):
        path = os.path.join(pyglet.resource.get_script_home(), 'data')
        filepath = os.path.join(path, const.EDITOR_FILE)
        f = file(filepath, 'w')
        for x in range(self.n_tiles_x):
            for y in range(self.n_tiles_y):
                if self.floor_grid[x][y] is not None:
                    text_pos = ' ' + str(x) + ' ' + str(y)
                    f.write('floor' + text_pos + '\n')
                    if self.grid[x][y] is not None:
                        if self.grid[x][y].fixed:
                            extra = ' True'
                        else:
                            extra = ' False'
                        f.write(self.grid[x][y].name + text_pos + extra +
                                '\n')
                    if self.robot_grid[x][y] is not None:
                        f.write('robot' + text_pos + '\n')

    def get_neighbours(self, x, y):
        neighbours = []
        if x > 0 and self.floor_grid[x-1][y]:
            neighbours.append((x-1, y))
        if x < self.n_tiles_x - 1 and self.floor_grid[x+1][y]:
            neighbours.append((x+1, y))
        if y > 0 and self.floor_grid[x][y-1]:
            neighbours.append((x, y-1))
        if y < self.n_tiles_y - 1 and self.floor_grid[x][y+1]:
            neighbours.append((x, y+1))
        return neighbours

    def get_near_objects(self, x, y):
        near_objects = []
        for n in self.get_neighbours(x, y):
            if self.grid[n[0]][n[1]] is not None:
                near_objects.append(self.grid[n[0]][n[1]])
        return near_objects

    def get_far_objects(self, x, y):
        far_objects = []
        for i in range(x - 1, -1, -1):
            if not self.floor_grid[i][y]:
                break
            if self.grid[i][y] and self.grid[i][y].blocker():
                far_objects.append(self.grid[i][y])
                break
        for i in range(x + 1, self.n_tiles_x):
            if not self.floor_grid[i][y]:
                break            
            if self.grid[i][y] and self.grid[i][y].blocker():
                far_objects.append(self.grid[i][y])
                break
        for i in range(y - 1, -1, -1):
            if not self.floor_grid[x][i]:
                break
            if self.grid[x][i] and self.grid[x][i].blocker():
                far_objects.append(self.grid[x][i])
                break
        for i in range(y + 1, self.n_tiles_y):
            if not self.floor_grid[x][i]:
                break            
            if self.grid[x][i] and self.grid[x][i].blocker():
                far_objects.append(self.grid[x][i])
                break
        return far_objects

    def remove_temp(self, obj):
        self.backup_obj(obj)
        self.remove_icon(obj.grid_x, obj.grid_y)

    def backup_obj(self, obj):
        if not obj.fixed:
            self.backup.append([obj.name, obj.grid_x, obj.grid_y, False])
        else:
            self.backup.append([obj.name, obj.grid_x, obj.grid_y])
            
    def backup_robots(self):
        for robot in self.robots:
            self.backup_obj(robot)

    def backup_state(self):
        self.backup = []
        self.backup_robots()
        
    def clear_robots(self):
        for robot in self.robots:
            robot.delete()
        self.robots = []
        self.robot_grid = [[None for j in xrange(self.n_tiles_y)]
                           for i in xrange(self.n_tiles_x)]

    def restore_backup(self):
        self.clear_robots()
        for i in self.backup:
            if len(i) <= 3:
                self.add(i[1], i[2], i[0])
            else:
                self.add(i[1], i[2], i[0], i[3])
        for tlist in self.things:
            for t in tlist:
                t.reset()

    def update_robot(self, old_grid_x, old_grid_y, grid_x, grid_y):
        self.robot_grid[grid_x][grid_y] = self.robot_grid[
            old_grid_x][old_grid_y]
        self.robot_grid[old_grid_x][old_grid_y] = None

    def robot_out(self, robot):
        self.robot_grid[robot.grid_x][robot.grid_y] = None
        self.robots.remove(robot)

    def all_robots_out(self):
        return len(self.robots) == 0

    def toggle_fix(self, grid_x, grid_y):
        if self.grid[grid_x][grid_y]:
            self.grid[grid_x][grid_y].toggle_fix()


class Wall(pyglet.sprite.Sprite):

    def __init__(self, x, y, batch, group, tilesize, side):
        x *= tilesize
        y *= tilesize
        if side == 'left':
            image = pyglet.resource.image('wall-vert.png')
            x -= image.width
            y -= image.width
        elif side == 'right':
            image = pyglet.resource.image('wall-vert.png')
            x += tilesize
            y -= image.width
        elif side == 'top':
            image = pyglet.resource.image('wall-horiz.png')
            y -= image.height
            x -= image.height
        else:
            image = pyglet.resource.image('wall-horiz.png')
            y += tilesize
            x -= image.height
        super(Wall, self).__init__(image, x, y, batch=batch, group=group)


class SidebarManager:

    def __init__(self, window, batch, tile_manager, editor):
        self.group = pyglet.graphics.OrderedGroup(2)
        self.icons_group = pyglet.graphics.OrderedGroup(3)
        self.selection_group = pyglet.graphics.OrderedGroup(4)        
        self.batch = batch
        self.window = window
        self.editor = editor
        self.tile_manager = tile_manager
        
        sidebar_img = pyglet.resource.image('sidebar.png')
        self.width = sidebar_img.width
        self.sidebar = pyglet.sprite.Sprite(sidebar_img,
                                            const.WIDTH - sidebar_img.width,
                                            0, batch=self.batch,
                                            group=self.group)

        self.space = 0

        self.simulator = Simulator(tile_manager, editor)

        self.already_chosen = [None for i in xrange(36)]
        self.icons = []
        self.new_icon('icon-stop.png', self.stop_simulation, [], False)
        self.new_icon('icon-go.png', self.start_simulation, [], False)
        self.new_icon('icon-eraser.png', self.set_mode_delete, [])
        if self.editor:
            self.add_all_icons()
        else:
            self.empty_space()
            self.add_not_fixed_icons()

        self.hovered = None
        self.selected = None
        self.started = False
        self.signal = None

        self.mode = const.LEMODE_NONE
        self.insert_icon = None

        self.mouse_x = 0
        self.mouse_y = 0

        pyglet.clock.schedule_interval(self.update, 1/40.0)

        self.window.push_handlers(self.on_mouse_press, self.on_mouse_motion)

    def stop_simulation(self):
        if self.started:
            self.started = False
            self.simulator.stop()
            if self.signal:
                self.signal.delete()
                self.signal = None

    def start_simulation(self):
        if not self.started:
            self.started = True
            self.simulator.start()
            img = pyglet.resource.image('fix-tag.png')
            pos = self.calc_space(1)
            self.signal = pyglet.sprite.Sprite(img, pos[0] - img.width / 2,
                                               pos[1] - img.height / 2,
                                               batch=self.batch,
                                               group=self.selection_group)
        
    def add_all_icons(self):
        self.new_icon('icon-select.png', self.set_mode_select, [])
        self.new_icon('tile-floor.png', self.set_mode_insert, ['floor'])
        self.new_icon('robot-normal.png', self.set_mode_insert, ['robot'])
        self.new_icon('icon-shock.png', self.set_mode_insert, ['shock'])
        self.new_icon('icon-chips.png', self.set_mode_insert, ['chips'])
        self.new_icon('thing01.png', self.set_mode_insert, ['thing01'])
        self.new_icon('thing02.png', self.set_mode_insert, ['thing02'])
        self.new_icon('thing03.png', self.set_mode_insert, ['thing03'])
        self.new_icon('thing04.png', self.set_mode_insert, ['thing04'])
        self.new_icon('thing05.png', self.set_mode_insert, ['thing05'])
        self.new_icon('thing06.png', self.set_mode_insert, ['thing06'])
        self.new_icon('thing07.png', self.set_mode_insert, ['thing07'])
        self.new_icon('thing08.png', self.set_mode_insert, ['thing08'])
        self.new_icon('icon-exit.png', self.set_mode_insert, ['exit'])

    def add_not_fixed_icons(self):
        for icon in self.tile_manager.not_fixed:
            self.new_icon_sprite(icon)
        
    def new_space(self):
        pos = self.calc_space(self.space)
        self.space += 1
        return pos

    def empty_space(self):
        self.space += 1
        self.icons.append(None)

    def calc_space(self, space):
        column = space % 2
        row = space / 2
        x = const.WIDTH - self.width * (2 - column) / 3
        y = const.HEIGHT - 40 - 50 * row
        return (x, y)

    def new_icon_sprite(self, sprite):
        self.new_icon_img(sprite.image, self.set_mode_insert, [sprite.name])

    def new_icon(self, imgfile, function, args, selectable=True):
        self.new_icon_img(pyglet.resource.image(imgfile), function, args,
                          selectable)
            
    def new_icon_img(self, image, function, args, selectable=True):
        x, y = self.new_space()
        sprite = pyglet.sprite.Sprite(image, x - image.width / 2,
                                      y - image.height / 2,
                                      batch=self.batch,
                                      group=self.icons_group)
        self.icons.append([sprite, function, args, selectable])

    def set_mode_delete(self):
        self.mode = const.LEMODE_DELETE

    def set_mode_select(self):
        self.mode = const.LEMODE_SELECT

    def set_mode_insert(self, icon):
        self.mode = const.LEMODE_INSERT
        self.insert_icon = icon

    def on_mouse_press(self, x, y, button, modifier):
        if button == pyglet.window.mouse.LEFT:
            if x >= const.WIDTH - self.sidebar.width:
                for i in range(len(self.icons)):
                    icon = self.icons[i]
                    if not icon or self.already_chosen[i]:
                        continue
                    icon_sprite = icon[0]
                    icon_function = icon[1]
                    icon_args = icon[2]
                    icon_selectable = icon[3]
                    if util.hit(icon_sprite, x, y):
                        if (not self.started or
                            icon_function == self.stop_simulation):
                            icon_function(*icon_args)
                            if icon_selectable:
                                self.select(icon_sprite)
                            return

    def unselectable_selected(self):
        for i in range(len(self.icons)):
            if (self.icons[i] and self.selected and
                self.selected.sprite == self.icons[i][0]):
                image = pyglet.resource.image('chosen.png')
                space = self.calc_space(i)
                sprite = pyglet.sprite.Sprite(image, space[0] - image.width/2,
                                              space[1] - image.height/2,
                                              batch=self.batch,
                                              group=self.selection_group)
                self.already_chosen[i] = sprite
                if self.selected:
                    self.selected.delete()
                self.selected = None
                self.mode = const.LEMODE_NONE

    def unchoose(self, sprite):
        for i in range(len(self.icons)):
            if (self.icons[i] and len(self.icons[i][2]) > 0 and
                sprite.name == self.icons[i][2][0]):
                if self.already_chosen[i]:
                    self.already_chosen[i].delete()
                    self.already_chosen[i] = None
                    return

    def select(self, icon_sprite):
        if self.selected:
            self.selected.delete()
        self.selected = Selection(icon_sprite, const.SELECT_GRNSQR,
                                  self.batch, self.selection_group)
        if self.hovered:
            self.hovered.delete()
            self.hovered = None
            
    def on_mouse_motion(self, x, y, dx, dy):
        self.mouse_x = x
        self.mouse_y = y

    def update(self, dt):
        self.mouse_hover()

    def mouse_hover(self):
        done = False
        for i in range(len(self.icons)):
            icon = self.icons[i]
            if not icon or self.already_chosen[i]:
                continue
            icon_sprite = icon[0]
            icon_selectable = icon[3]
            if icon_selectable:
                if not done and util.hit(icon_sprite, self.mouse_x,
                                         self.mouse_y):
                    if (not self.selected or
                        self.selected.sprite is not icon_sprite):
                        self.hovered = Selection(icon_sprite,
                                                 const.SELECT_YLWSQR,
                                                 self.batch,
                                                 self.selection_group)
                        done = True
                else:
                    if self.hovered and self.hovered.sprite == icon_sprite:
                        self.hovered.delete()
                        self.hovered = None

    def finish(self):
        self.window.pop_handlers()


class Tile(pyglet.sprite.Sprite):

    def __init__(self, x, y, batch, group):
        image = pyglet.resource.image('tile-floor.png')
        super(Tile, self).__init__(image, x * image.width, y * image.height,
                                   batch=batch, group=group)
        self.name = 'floor'
        self.fixed = True


class GameObject(pyglet.sprite.Sprite):

    def __init__(self, image, x, y, batch, group, name, tile_manager):
        super(GameObject, self).__init__(image, x * const.TILESIZE,
                                         y * const.TILESIZE,
                                         batch=batch, group=group)
        self.name = name
        self.tnumber = -1
        self.grid_x = x
        self.grid_y = y
        self.tile_manager = tile_manager
        self.fixed = True
        self.fix_tag = None

    def feared(self):
        pass

    def loved(self):
        pass

    def is_feared(self):
        return False

    def is_loved(self):
        return False

    def reset(self):
        pass

    def blocker(self):
        return False

    def unfix(self):
        self.fixed = False
        ftag = pyglet.resource.image('fix-tag.png')
        self.fix_tag = pyglet.sprite.Sprite(ftag,
                       (self.grid_x + 0.5) * const.TILESIZE - ftag.width / 2,
                       (self.grid_y + 0.5) * const.TILESIZE - ftag.height / 2,
                        batch=self.batch, group=self.group)

    def fix(self):
        self.fixed = True
        if self.fix_tag:
            self.fix_tag.delete()
            self.fix_tag = None

    def toggle_fix(self):
        if self.fixed:
            self.unfix()
        else:
            self.fix()

    def delete(self):
        if self.fix_tag:
            self.fix_tag.delete()
        super(GameObject, self).delete()


class ShockTrap(GameObject):

    def __init__(self, x, y, batch, group, tile_manager, fixed):
        image = pyglet.resource.image('icon-shock.png')
        super(ShockTrap, self).__init__(image, x, y, batch, group, 'shock',
                                        tile_manager)
        if not fixed:
            self.unfix()

    def affect(self, robot):
        robot.shock()
        self.tile_manager.remove_temp(self)


class BagOfChips(GameObject):

    def __init__(self, x, y, batch, group, tile_manager, fixed):
        image = pyglet.resource.image('icon-chips.png')
        super(BagOfChips, self).__init__(image, x, y, batch, group, 'chips',
                                         tile_manager)
        if not fixed:
            self.unfix()

    def affect(self, robot):
        robot.eat_chips()
        self.tile_manager.remove_temp(self)
        

class Exit(GameObject):

    def __init__(self, x, y, batch, group, tile_manager):
        image = pyglet.resource.image('icon-exit.png') 
        super(Exit, self).__init__(image, x, y, batch, group, 'exit',
                                   tile_manager)

    def affect(self, robot):
        robot.win()


class Thing(GameObject):

    def __init__(self, number, x, y, batch, group, tile_manager, fixed):
        self.tag_group = pyglet.graphics.OrderedGroup(4)

        name = 'thing%02d' % number
        image = pyglet.resource.image(name + '.png')
        super(Thing, self).__init__(image, x, y, batch, group, name,
                                    tile_manager)
        
        if not fixed:
            self.unfix()
        self.tnumber = number
        self.batch = batch

        self.tag = None
        self.status = const.TSTAT_NEUTRAL

    def feared(self):
        if not self.is_feared() and not self.is_loved():
            self.status = const.TSTAT_FEARED
            image = pyglet.resource.image('tag-fear.png')
            if self.tag:
                self.tag.delete()
            self.tag = pyglet.sprite.Sprite(image, (self.grid_x + 0.5) *
                                        const.TILESIZE - image.width / 2,
                                        (self.grid_y + 0.5) * const.TILESIZE -
                                        image.height / 2,
                                        batch=self.batch, group=self.tag_group)
            for thing in self.tile_manager.things[self.tnumber-1]:
                if (thing is not self and
                    self.tile_manager.grid[thing.grid_x][thing.grid_y] ==
                    thing):
                    thing.feared()
        
    def loved(self):
        if not self.is_loved() and not self.is_feared():
            self.status = const.TSTAT_LOVED
            image = pyglet.resource.image('tag-love.png')
            if self.tag:
                self.tag.delete()
            self.tag = pyglet.sprite.Sprite(image, (self.grid_x + 0.5) *
                                        const.TILESIZE - image.width / 2,
                                        (self.grid_y + 0.5) * const.TILESIZE -
                                        image.height / 2,
                                        batch=self.batch, group=self.tag_group)
            for thing in self.tile_manager.things[self.tnumber-1]:
                if (thing is not self and
                    self.tile_manager.grid[thing.grid_x][thing.grid_y] ==
                    thing):
                    thing.loved()

    def is_feared(self):
        return self.status == const.TSTAT_FEARED

    def is_loved(self):
        return self.status == const.TSTAT_LOVED

    def reset(self):
        self.status = const.TSTAT_NEUTRAL
        if self.tag:
            self.tag.delete()
            self.tag = None

    def blocker(self):
        return True


class Robot(pyglet.sprite.Sprite):

    def __init__(self, x, y, batch, group, tile_manager):
        self.tile_manager = tile_manager

        self.name = 'robot'
        fname = 'robot.png'
        complete_img = pyglet.resource.image(fname)
        image_seq = pyglet.image.ImageGrid(complete_img, 4, 12)
        
        self.robot_normal_right = image_seq[0]
        self.robot_normal_left = image_seq[12]
        self.robot_normal_up = image_seq[24]
        self.robot_normal_down = image_seq[36]
        self.robot_scared_right = image_seq[3]
        self.robot_scared_left = image_seq[15]
        self.robot_scared_up = image_seq[27]
        self.robot_scared_down = image_seq[39]
        self.robot_happy_right = image_seq[6]
        self.robot_happy_left = image_seq[18]
        self.robot_happy_up = image_seq[30]
        self.robot_happy_down = image_seq[42]

        self.walking_rate = 0.2
        self.running_rate = 0.1
        
        self.robot_w_normal_right = pyglet.image.Animation.from_image_sequence(
            image_seq[1:3], self.walking_rate, True)
        self.robot_w_normal_left = pyglet.image.Animation.from_image_sequence(
            image_seq[13:15], self.walking_rate, True)
        self.robot_w_normal_up = pyglet.image.Animation.from_image_sequence(
            image_seq[25:27], self.walking_rate, True)
        self.robot_w_normal_down = pyglet.image.Animation.from_image_sequence(
            image_seq[37:39], self.walking_rate, True)
        
        self.robot_w_scared_right = pyglet.image.Animation.from_image_sequence(
            image_seq[4:6], self.running_rate, True)
        self.robot_w_scared_left = pyglet.image.Animation.from_image_sequence(
            image_seq[16:18], self.running_rate, True)
        self.robot_w_scared_up = pyglet.image.Animation.from_image_sequence(
            image_seq[28:30], self.running_rate, True)
        self.robot_w_scared_down = pyglet.image.Animation.from_image_sequence(
            image_seq[40:42], self.running_rate, True)
        
        self.robot_w_happy_right = pyglet.image.Animation.from_image_sequence(
            image_seq[7:9], self.running_rate, True)
        self.robot_w_happy_left = pyglet.image.Animation.from_image_sequence(
            image_seq[19:21], self.running_rate, True)
        self.robot_w_happy_up = pyglet.image.Animation.from_image_sequence(
            image_seq[31:33], self.running_rate, True)
        self.robot_w_happy_down = pyglet.image.Animation.from_image_sequence(
            image_seq[43:45], self.running_rate, True)

        self.robot_shocked = pyglet.image.Animation.from_image_sequence(
            image_seq[45:48], 0.1, True)
        self.robot_eating = pyglet.image.Animation.from_image_sequence(
            image_seq[33:36], 0.2, True)
        self.robot_dancing = pyglet.image.Animation.from_image_sequence(
            image_seq[21:24], 0.2, True)

        self.grid_x = x
        self.grid_y = y
        
        super(Robot, self).__init__(self.robot_normal_down, x * const.TILESIZE,
                                    y * const.TILESIZE,
                                    batch=batch, group=group)

        self.animation_loop = 0
        self.animation_stop = None
        self.animation_to_stop = None
        self.busy = False
        self.winning = False

        self.moves = []
        self.moving = None
        self.speed = const.TILESIZE / 8 * 50
        self.reacting_to = None
        self.fixed = True

    def shock(self):
        self.clear_moving()
        self.image = self.robot_shocked
        self.busy = True
        self.animation_loop = 2
        self.animation_to_stop = self.stop_shock

    def stop_shock(self):
        self.fear_near()
        self.normal()

    def eat_chips(self):
        self.clear_moving()
        self.image = self.robot_eating
        self.busy = True
        self.animation_loop = 2
        self.animation_to_stop = self.stop_eat_chips

    def stop_eat_chips(self):
        self.love_near()
        self.normal()

    def normal(self):
        self.image = self.robot_normal_down
        self.busy = False

    def on_animation_end(self):
        if self.animation_loop > 0:
            self.animation_loop -= 1
            if self.animation_loop == 0 and self.animation_to_stop:
                self.animation_stop = self.animation_to_stop
                self.animation_to_stop = None

    def fear_near(self):
        near_objs = self.tile_manager.get_near_objects(self.grid_x,
                                                       self.grid_y)
        for obj in near_objs:
            obj.feared()

    def love_near(self):
        near_objs = self.tile_manager.get_near_objects(self.grid_x,
                                                       self.grid_y)
        for obj in near_objs:
            obj.loved()

    def run_away(self, obj):
        if self.reacting_to is not obj:
            self.moves = []
            self.reacting_to = obj
            dx = self.grid_x - obj.grid_x
            dy = self.grid_y - obj.grid_y
            if dx < 0:
                self.image = self.robot_w_scared_left
                dx = -1
            elif dx > 0:
                self.image = self.robot_w_scared_right
                dx = 1
            elif dy < 0:
                self.image = self.robot_w_scared_down
                dy = -1
            elif dy > 0:
                self.image = self.robot_w_scared_up
                dy = 1
            x = self.grid_x + dx
            y = self.grid_y + dy
            while (self.tile_manager.floor_grid[x][y] and
                   (not self.tile_manager.grid[x][y] or
                    not self.tile_manager.grid[x][y].blocker())):
                x += dx
                y += dy
                self.moves.append([dx, dy])
            self.x = self.grid_x * const.TILESIZE
            self.y = self.grid_y * const.TILESIZE
            self.moving = False

    def run_towards(self, obj):
        if self.reacting_to is not obj:
            self.moves = []
            self.reacting_to = obj
            dx = obj.grid_x - self.grid_x
            dy = obj.grid_y - self.grid_y
            if dx < 0:
                self.image = self.robot_w_happy_left
                dx = -1
            elif dx > 0:
                self.image = self.robot_w_happy_right
                dx = 1
            elif dy < 0:
                self.image = self.robot_w_happy_down
                dy = -1
            elif dy > 0:
                self.image = self.robot_w_happy_up
                dy = 1
            x = self.grid_x + dx
            y = self.grid_y + dy
            while self.tile_manager.grid[x][y] is not obj:
                x += dx
                y += dy
                self.moves.append([dx, dy])
            self.x = self.grid_x * const.TILESIZE
            self.y = self.grid_y * const.TILESIZE
            self.moving = False
            
    def update(self, dt):
        if self.animation_stop:
            self.animation_stop()
            self.animation_stop = None
        if self.winning: return
        if not self.moving and len(self.moves) > 0:
            self.moving = self.moves.pop()
        if self.moving:
            self.x += self.moving[0] * self.speed * dt
            self.y += self.moving[1] * self.speed * dt
            if self.passed_grid():
                old_grid_x = self.grid_x
                old_grid_y = self.grid_y
                self.grid_x += self.moving[0]
                self.grid_y += self.moving[1]
                self.x = self.grid_x * const.TILESIZE
                self.y = self.grid_y * const.TILESIZE                
                self.tile_manager.update_robot(old_grid_x, old_grid_y,
                                               self.grid_x, self.grid_y)
                if len(self.moves) > 0:
                    self.moving = self.moves.pop()
                else:
                    self.reacting_to = None
                    self.moving = None

    def passed_grid(self):
        if self.moving[0] < 0:
            return self.x <= (self.grid_x + self.moving[0]) * const.TILESIZE
        if self.moving[0] > 0:
            return self.x >= (self.grid_x + self.moving[0]) * const.TILESIZE
        if self.moving[1] < 0:
            return self.y <= (self.grid_y + self.moving[1]) * const.TILESIZE
        if self.moving[1] > 0:
            return self.y >= (self.grid_y + self.moving[1]) * const.TILESIZE
        return False
        
    def clear_moving(self):
        self.moves = []
        self.moving = None

    def other_direction(self, x, y):
        if self.moving:
            if self.moving[0] > 0 and x < self.grid_x:
                return True
            if self.moving[0] < 0 and x > self.grid_x:
                return True
            if self.moving[1] > 0 and y < self.grid_y:
                return True
            if self.moving[1] < 0 and y > self.grid_y:
                return True            
        return False

    def win(self):
        if not self.winning:
            self.winning = True
            self.image = self.robot_dancing
            self.animation_loop = 2
            self.animation_to_stop = self.won

    def won(self):
        self.tile_manager.robot_out(self)
        self.delete()


class Simulator:

    def __init__(self, tile_manager, editor):
        self.tile_manager = tile_manager
        pyglet.clock.schedule_interval(self.update, 1/40.0)

        self.running = False
        self.editor = editor
        self.level_done = False

    def start(self):
        if not self.running:
            self.running = True
            self.tile_manager.backup_state()

    def stop(self):
        if self.running:
            self.running = False
            self.tile_manager.restore_backup()

    def check_all_events(self):
        for robot in self.tile_manager.robots:
            self.check_events(robot)

    def check_events(self, robot):
        if not robot.busy:
            grid_x = robot.grid_x
            grid_y = robot.grid_y
        
            on_tile = self.tile_manager.grid[grid_x][grid_y]
            if on_tile:
                on_tile.affect(robot)
                return
        
            near_objs = self.tile_manager.get_near_objects(grid_x, grid_y)
            for obj in near_objs:
                if obj.is_feared():
                    robot.run_away(obj)
                    return
        
            far_objs = self.tile_manager.get_far_objects(grid_x, grid_y)
            min_dist = 100
            best_obj = None
            for obj in far_objs:
                if obj not in near_objs and obj.is_loved():
                    if not robot.other_direction(obj.grid_x, obj.grid_y):
                        dist = (abs(obj.grid_x - robot.grid_x) +
                                abs(obj.grid_y - robot.grid_y))
                        if dist < min_dist:
                            min_dist = dist
                            best_obj = obj

            if best_obj:
                robot.run_towards(best_obj)
                return        

    def update(self, dt):
        if self.running:
            for robot in self.tile_manager.robots:
                robot.update(dt)
                self.check_events(robot)
            if self.tile_manager.all_robots_out() and not self.editor:
                self.next_level()

    def next_level(self):
        self.level_done = True
