import math

def hit(sprite, x, y):
    return (x >= sprite.x and x < sprite.x + sprite.width and
            y >= sprite.y and y < sprite.y + sprite.height)

def hit_opaque(sprite, x, y):
    return (hit(sprite, x, y) and ord(sprite.image.get_image_data().
            get_data('A', sprite.width)[x - sprite.x + sprite.width *
                                        (y - sprite.y)]) > 0)

def go_towards(pos_x, pos_y, target_x, target_y, speed):
    dx = pos_x - target_x
    dy = pos_y - target_y
    dist = math.hypot(dx, dy)
    if dist <= speed:
        pos_x = target_x
        pos_y = target_y
    else:
        pos_x -= speed * dx / dist
        pos_y -= speed * dy / dist
    return pos_x, pos_y
